<?php
  /* vim: set expandtab tabstop=4 softtabstop=4 shiftwidth=4:
  Codificación: UTF-8
  +----------------------------------------------------------------------+
  | Elastix version 2.4.0-12                                               |
  | http://www.elastix.org                                               |
  +----------------------------------------------------------------------+
  | Copyright (c) 2006 Palosanto Solutions S. A.                         |
  +----------------------------------------------------------------------+
  | Cdla. Nueva Kennedy Calle E 222 y 9na. Este                          |
  | Telfs. 2283-268, 2294-440, 2284-356                                  |
  | Guayaquil - Ecuador                                                  |
  | http://www.palosanto.com                                             |
  +----------------------------------------------------------------------+
  | The contents of this file are subject to the General Public License  |
  | (GPL) Version 2 (the "License"); you may not use this file except in |
  | compliance with the License. You may obtain a copy of the License at |
  | http://www.opensource.org/licenses/gpl-license.php                   |
  |                                                                      |
  | Software distributed under the License is distributed on an "AS IS"  |
  | basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. See  |
  | the License for the specific language governing rights and           |
  | limitations under the License.                                       |
  +----------------------------------------------------------------------+
  | The Original Code is: Elastix Open Source.                           |
  | The Initial Developer of the Original Code is PaloSanto Solutions    |
  +----------------------------------------------------------------------+
  $Id: index.php,v 1.1 2014-07-21 12:07:50 Jie jie@opticaller.com Exp $ */
//include elastix framework
include_once "libs/paloSantoGrid.class.php";
include_once "libs/paloSantoForm.class.php";
include_once "libs/paloSantoConfig.class.php";

function _moduleContent(&$smarty, $module_name)
{
    //include module files
    include_once "modules/$module_name/configs/default.conf.php";
    include_once "modules/$module_name/libs/paloSantopbxconnect.class.php";

    //include file language agree to elastix configuration
    //if file language not exists, then include language by default (en)
    $lang=get_language();
    $base_dir=dirname($_SERVER['SCRIPT_FILENAME']);
    $lang_file="modules/$module_name/lang/$lang.lang";
    if (file_exists("$base_dir/$lang_file")) include_once "$lang_file";
    else include_once "modules/$module_name/lang/en.lang";

    //global variables
    global $arrConf;
    global $arrConfModule;
    global $arrLang;
    global $arrLangModule;
    $arrConf = array_merge($arrConf,$arrConfModule);
    $arrLang = array_merge($arrLang,$arrLangModule);

    //folder path for custom templates
    $templates_dir=(isset($arrConf['templates_dir']))?$arrConf['templates_dir']:'themes';
    $local_templates_dir="$base_dir/modules/$module_name/".$templates_dir.'/'.$arrConf['theme'];

    //conexion resource
    //$pDB = new paloDB($arrConf['dsn_conn_database']);
    $pDB = "";


    //actions
    $action = getAction();
    $content = "";

    switch($action){
        case "save_new":
            $content = saveNewpbxconnect($smarty, $module_name, $local_templates_dir, $pDB, $arrConf);
            break;
        case "start":
            $content = checkFormpbxconnect($smarty, $module_name, $local_templates_dir, $pDB, $arrConf);
            if($content == "TURE"){                
//                $response = exec('/etc/init.d/pbxconnect -v start');
                $response = exec('sudo service pbxconnect start');
                $content = testFormpbxconnect($smarty, $module_name, $local_templates_dir, $pDB, $arrConf,$response);
            }
            break;
        case "stop":
//            $response = exec('/etc/init.d/pbxconnect stop');
            $response = exec('sudo service pbxconnect stop');
            $content = testFormpbxconnect($smarty, $module_name, $local_templates_dir, $pDB, $arrConf,$response);
            break;
        case "sync":
            $response = exec('sh /usr/pbxconnect/force_sync');
            if(strlen($response)==0){
                $response = "Sync failed";
            }
            $content = testFormpbxconnect($smarty, $module_name, $local_templates_dir, $pDB, $arrConf,$response);
            break;
        default: // view_form
            $content = viewFormpbxconnect($smarty, $module_name, $local_templates_dir, $pDB, $arrConf);
            break;
    }
    return $content;
}

function viewFormpbxconnect($smarty, $module_name, $local_templates_dir, &$pDB, $arrConf)
{
    $ppbxconnect = new paloSantopbxconnect($pDB);
    $arrFormpbxconnect = createFieldForm();
    $oForm = new paloForm($smarty,$arrFormpbxconnect);

    //begin, Form data persistence to errors and other events.
    $_DATA = $_POST;

    foreach($arrFormpbxconnect as $key => $value){
        $valueInConf = readValueFromConf($key);
        //print_r($key."=====>".$valueInConf."<br>");
        $_DATA[$key] = isset($_POST[$key])?$_POST[$key]:$valueInConf;
    }

    $action = getParameter("action");
    $id     = getParameter("id");
    $smarty->assign("ID", $id); //persistence id with input hidden in tpl

    if($action=="view")
        $oForm->setViewMode();
    else if($action=="view_edit" || getParameter("save_edit"))
        $oForm->setEditMode();
    //end, Form data persistence to errors and other events.

    if($action=="view" || $action=="view_edit"){ // the action is to view or view_edit.
        $datapbxconnect = $ppbxconnect->getpbxconnectById($id);
        if(is_array($datapbxconnect) & count($datapbxconnect)>0)
            $_DATA = $datapbxconnect;
        else{
            $smarty->assign("mb_title", _tr("Error get Data"));
            $smarty->assign("mb_message", $ppbxconnect->errMsg);
        }
    }

    $smarty->assign("SAVE", _tr("Save"));
    $smarty->assign("EDIT", _tr("Edit"));
    $smarty->assign("CANCEL", _tr("Cancel"));
    $smarty->assign("START", _tr("Start Module"));
    $smarty->assign("STOP", _tr("Stop Module"));
    $smarty->assign("SYNC", _tr("Sync"));
    $smarty->assign("REQUIRED_FIELD", _tr("Required field"));
    $smarty->assign("MODULE_CONTROL", _tr("Module Operation"));
    $smarty->assign("MODULE_CONFIG", _tr("Module Configuration"));
    //$smarty->assign("icon", "modules/$module_name/images/logo.png");
    $smarty->assign("LOGO", "<div><img src='modules/$module_name/images/logo.png' align='left' alt='Opticaller' title='Opticaller'></div>");
    $smarty->assign("INTRODUCTION", _tr(introduction()));

    $htmlForm = $oForm->fetchForm("$local_templates_dir/form.tpl",_tr(""), $_DATA);
    $content = "<form  method='POST' style='margin-bottom:0;' action='?menu=$module_name'>".$htmlForm."</form>";

    return $content;
}

function saveNewpbxconnect($smarty, $module_name, $local_templates_dir, &$pDB, $arrConf)
{
    $ppbxconnect = new paloSantopbxconnect($pDB);
    $arrFormpbxconnect = createFieldForm();
    $oForm = new paloForm($smarty,$arrFormpbxconnect);
    
    if(!$oForm->validateForm($_POST)){
        // Validation basic, not empty and VALIDATION_TYPE 
        $smarty->assign("mb_title", _tr("Validation Error"));
        $arrErrores = $oForm->arrErroresValidacion;
        $strErrorMsg = "<b>"._tr("The following fields contain errors").":</b><br/>";
        if(is_array($arrErrores) && count($arrErrores) > 0){
            foreach($arrErrores as $k=>$v)
                $strErrorMsg .= "$k, ";
        }
        $smarty->assign("mb_message", $strErrorMsg);
        $content = viewFormpbxconnect($smarty, $module_name, $local_templates_dir, $pDB, $arrConf);
    }
    else{
        //NO ERROR, HERE IMPLEMENTATION OF SAVE
        $_DATA = $_POST;
        $smarty->assign("mb_title", _tr("System Info:"));
        foreach($_DATA as $key => $value){
            savePost($key,$value);
        }        
        
        
        $response = exec('service pbxconnect check');
        if($response == "Pbxconnect is running"){
            $smarty->assign("mb_message", "Successfully Saved.".exec('sudo service pbxconnect restart'));
        }else{
            $smarty->assign("mb_message", "Successfully Saved.");
        }
        $content = viewFormpbxconnect($smarty, $module_name, $local_templates_dir, $pDB, $arrConf);
    }

    return $content;
}

function checkFormpbxconnect($smarty, $module_name, $local_templates_dir, &$pDB, $arrConf)
{
    $ppbxconnect = new paloSantopbxconnect($pDB);
    $arrFormpbxconnect = createFieldForm();
    $oForm = new paloForm($smarty,$arrFormpbxconnect);
    $_DATA = $_POST;	
    
    if(!$oForm->validateForm($_POST)){
        // Validation basic, not empty and VALIDATION_TYPE 
        $smarty->assign("mb_title", _tr("Validation Error"));
        $arrErrores = $oForm->arrErroresValidacion;
        $strErrorMsg = "<b>"._tr("The following fields contain errors").":</b><br/>";
        if(is_array($arrErrores) && count($arrErrores) > 0){
            foreach($arrErrores as $k=>$v)
                $strErrorMsg .= "$k, ";
        }
        $smarty->assign("mb_message", $strErrorMsg);
        $content = viewFormpbxconnect($smarty, $module_name, $local_templates_dir, $pDB, $arrConf);
    }
    else{
	    foreach($arrFormpbxconnect as $key => $value){
            $content = "TURE";
		    $valueInConf = readValueFromConf($key);
		    if($_DATA[$key]!=$valueInConf){
                $smarty->assign("mb_title", _tr("Validation Error"));
                $strErrorMsg = "<b>"._tr("Save changes first!").":</b><br/>";
                $smarty->assign("mb_message", $strErrorMsg);
                $content = viewFormpbxconnect($smarty, $module_name, $local_templates_dir, $pDB, $arrConf);
                break;
		    }
        }
    }
    return $content;
}


function testFormpbxconnect($smarty, $module_name, $local_templates_dir, $pDB, $arrConf,$response)
{
    $ppbxconnect = new paloSantopbxconnect($pDB);
    $arrFormpbxconnect = createFieldForm();
    $oForm = new paloForm($smarty,$arrFormpbxconnect);
    $smarty->assign("mb_title", _tr("System Info:"));
    $smarty->assign("mb_message", $response);
    $content = viewFormpbxconnect($smarty, $module_name, $local_templates_dir, $pDB, $arrConf);
    return $content;
}



function createFieldForm()
{

    $arrOptions = array('val1' => 'Value 1', 'val2' => 'Value 2', 'val3' => 'Value 3');
    //$boolean = array("true" => _tr("True"), "false" => _tr("False"));
    //$numFormat = array("E164" => _tr("E164 eg:467XXXX"), "PLUS" => _tr("Plus eg:+467XXXX"), "AREA" => _tr("Area eg:00467XXXX"), "NATIONAL" =>_tr("National eg:07XXXX"), "NO" =>_tr("None eg:7XXXX"));
    $arrFields = array(
            "userkey"   => array(      "LABEL"                  => _tr("User key"),
                                            "REQUIRED"               => "yes",
                                            "INPUT_TYPE"             => "TEXT",
                                            "INPUT_EXTRA_PARAM"      => array("style" => "width:400px"),
                                            "VALIDATION_TYPE"        => "text",
                                            "VALIDATION_EXTRA_PARAM" => ""
                                            ),

            "secretkey"   => array(      "LABEL"                  => _tr("Secret key"),
                                            "REQUIRED"               => "yes",
                                            "INPUT_TYPE"             => "TEXT",
                                            "INPUT_EXTRA_PARAM"      => array("style" => "width:400px"),
                                            "VALIDATION_TYPE"        => "text",
                                            "VALIDATION_EXTRA_PARAM" => ""
                                            ),
            "data_accessnumber_list"   => array(      "LABEL"                  => _tr("Data Access Number"),
                                            "REQUIRED"               => "no",
                                            "INPUT_TYPE"             => "TEXT",
                                            "INPUT_EXTRA_PARAM"      => array("style" => "width:400px"),
                                            "VALIDATION_TYPE"        => "text",
                                            "VALIDATION_EXTRA_PARAM" => ""
                                            ),
            "ast_prim_manager_usr"   => array(      "LABEL"                  => _tr("Elastix Username"),
                                            "REQUIRED"               => "yes",
                                            "INPUT_TYPE"             => "TEXT",
                                            "INPUT_EXTRA_PARAM"      => array("style" => "width:400px"),
                                            "VALIDATION_TYPE"        => "text",
                                            "VALIDATION_EXTRA_PARAM" => ""
                                            ),
            "ast_prim_manager_pwd"   => array(      "LABEL"                  => _tr("Elastix Password"),
                                            "REQUIRED"               => "yes",
                                            "INPUT_TYPE"             => "PASSWORD",
                                            "INPUT_EXTRA_PARAM"      => array("style" => "width:400px"),
                                            "VALIDATION_TYPE"        => "text",
                                            "VALIDATION_EXTRA_PARAM" => ""
                                            ),
            "port"   => array(      "LABEL"                  => _tr("HTTP Port"),
                                            "REQUIRED"               => "yes",
                                            "INPUT_TYPE"             => "TEXT",
                                            "INPUT_EXTRA_PARAM"      => array("style" => "width:400px"),
                                            "VALIDATION_TYPE"        => "text",
                                            "VALIDATION_EXTRA_PARAM" => ""
                                            ),
            "port_ssl"   => array(      "LABEL"                  => _tr("HTTPs Port"),
                                            "REQUIRED"               => "yes",
                                            "INPUT_TYPE"             => "TEXT",
                                            "INPUT_EXTRA_PARAM"      => array("style" => "width:400px"),
                                            "VALIDATION_TYPE"        => "text",
                                            "VALIDATION_EXTRA_PARAM" => ""
                                            ),
/*
            "ast_prim_ip_addr"   => array(      "LABEL"                  => _tr("AST_PRIM_IP_ADDR"),
                                            "REQUIRED"               => "yes",
                                            "INPUT_TYPE"             => "TEXT",
                                            "INPUT_EXTRA_PARAM"      => "",
                                            "VALIDATION_TYPE"        => "text",
                                            "VALIDATION_EXTRA_PARAM" => ""
                                            ),
            "ast_prim_port"   => array(      "LABEL"                  => _tr("AST_PRIM_PORT"),
                                            "REQUIRED"               => "yes",
                                            "INPUT_TYPE"             => "TEXT",
                                            "INPUT_EXTRA_PARAM"      => "",
                                            "VALIDATION_TYPE"        => "text",
                                            "VALIDATION_EXTRA_PARAM" => ""
                                            ),
            "ast_prim_manager_usr"   => array(      "LABEL"                  => _tr("AST_PRIM_MANAGER_USR"),
                                            "REQUIRED"               => "yes",
                                            "INPUT_TYPE"             => "TEXT",
                                            "INPUT_EXTRA_PARAM"      => "",
                                            "VALIDATION_TYPE"        => "text",
                                            "VALIDATION_EXTRA_PARAM" => ""
                                            ),
            "ast_prim_manager_pwd"   => array(      "LABEL"                  => _tr("AST_PRIM_MANAGER_PWD"),
                                            "REQUIRED"               => "yes",
                                            "INPUT_TYPE"             => "TEXT",
                                            "INPUT_EXTRA_PARAM"      => "",
                                            "VALIDATION_TYPE"        => "text",
                                            "VALIDATION_EXTRA_PARAM" => ""
                                            ),
            "ami_event_listener_set"   => array(      "LABEL"                  => _tr("AMI_EVENT_LISTENER_SET"),
                                            "REQUIRED"               => "yes",
                                            "INPUT_TYPE"             => "RADIO",
                                            "INPUT_EXTRA_PARAM"      => $boolean,
                                            "VALIDATION_TYPE"        => "text",
                                            "VALIDATION_EXTRA_PARAM" => ""
                                            ),
            "ami_event_listener_pbx_send_enable"   => array(      "LABEL"                  => _tr("AMI_EVENT_LISTENER_PBX_SEND_ENABLE"),
                                            "REQUIRED"               => "yes",
                                            "INPUT_TYPE"             => "RADIO",
                                            "INPUT_EXTRA_PARAM"      => $boolean,
                                            "VALIDATION_TYPE"        => "text",
                                            "VALIDATION_EXTRA_PARAM" => ""
                                            ),
            "ami_event_listener_pbx_ipaddress"   => array(      "LABEL"                  => _tr("AMI_EVENT_LISTENER_PBX_IPADDRESS"),
                                            "REQUIRED"               => "yes",
                                            "INPUT_TYPE"             => "TEXT",
                                            "INPUT_EXTRA_PARAM"      => "",
                                            "VALIDATION_TYPE"        => "text",
                                            "VALIDATION_EXTRA_PARAM" => ""
                                            ),
            "ami_event_listener_pbx_port"   => array(      "LABEL"                  => _tr("AMI_EVENT_LISTENER_PBX_PORT"),
                                            "REQUIRED"               => "yes",
                                            "INPUT_TYPE"             => "TEXT",
                                            "INPUT_EXTRA_PARAM"      => "",
                                            "VALIDATION_TYPE"        => "text",
                                            "VALIDATION_EXTRA_PARAM" => ""
                                            ),
            "line_state_pbx_accept_num_format"   => array(      "LABEL"                  => _tr("LINE_STATE_PBX_ACCEPT_NUM_FORMAT"),
                                            "REQUIRED"               => "yes",
                                            "INPUT_TYPE"             => "SELECT",
                                            "INPUT_EXTRA_PARAM"      => $numFormat,
                                            "VALIDATION_TYPE"        => "text",
                                            "VALIDATION_EXTRA_PARAM" => ""
                                            ),
            "country_code"   => array(      "LABEL"                  => _tr("COUNTRY_CODE"),
                                            "REQUIRED"               => "yes",
                                            "INPUT_TYPE"             => "TEXT",
                                            "INPUT_EXTRA_PARAM"      => "",
                                            "VALIDATION_TYPE"        => "text",
                                            "VALIDATION_EXTRA_PARAM" => ""
                                            ),
            "line_state_pbx_accept_exten"   => array(      "LABEL"                  => _tr("LINE_STATE_PBX_ACCEPT_EXTEN"),
                                            "REQUIRED"               => "yes",
                                            "INPUT_TYPE"             => "TEXT",
                                            "INPUT_EXTRA_PARAM"      => "",
                                            "VALIDATION_TYPE"        => "text",
                                            "VALIDATION_EXTRA_PARAM" => ""
                                            ),
            "call_history_file_path"   => array(      "LABEL"                  => _tr("CALL_HISTORY_FILE_PATH"),
                                            "REQUIRED"               => "yes",
                                            "INPUT_TYPE"             => "TEXT",
                                            "INPUT_EXTRA_PARAM"      => "",
                                            "VALIDATION_TYPE"        => "text",
                                            "VALIDATION_EXTRA_PARAM" => ""
                                            ),
            "data_accessnumber_list"   => array(      "LABEL"                  => _tr("DATA_ACCESSNUMBER_LIST"),
                                            "REQUIRED"               => "yes",
                                            "INPUT_TYPE"             => "TEXT",
                                            "INPUT_EXTRA_PARAM"      => "",
                                            "VALIDATION_TYPE"        => "text",
                                            "VALIDATION_EXTRA_PARAM" => ""
                                            ),
            "region_accessnumber_support"   => array(      "LABEL"                  => _tr("REGION_ACCESSNUMBER_SUPPORT"),
                                            "REQUIRED"               => "yes",
                                            "INPUT_TYPE"             => "RADIO",
                                            "INPUT_EXTRA_PARAM"      => $boolean,
                                            "VALIDATION_TYPE"        => "text",
                                            "VALIDATION_EXTRA_PARAM" => ""
                                            ),
            "cache_accessnumber_ct"   => array(      "LABEL"                  => _tr("CACHE_ACCESSNUMBER_CT"),
                                            "REQUIRED"               => "yes",
                                            "INPUT_TYPE"             => "RADIO",
                                            "INPUT_EXTRA_PARAM"      => $boolean,
                                            "VALIDATION_TYPE"        => "text",
                                            "VALIDATION_EXTRA_PARAM" => ""
                                            ),
            "cache_accessnumber_cb"   => array(      "LABEL"                  => _tr("CACHE_ACCESSNUMBER_CB"),
                                            "REQUIRED"               => "yes",
                                            "INPUT_TYPE"             => "RADIO",
                                            "INPUT_EXTRA_PARAM"      => $boolean,
                                            "VALIDATION_TYPE"        => "text",
                                            "VALIDATION_EXTRA_PARAM" => ""
                                            ),
*/
            );
    return $arrFields;
}

function getAction()
{
    if(getParameter("save_new")) //Get parameter by POST (submit)
        return "save_new";
    else if(getParameter("save_edit"))
        return "save_edit";
    else if(getParameter("delete")) 
        return "delete";
    else if(getParameter("new_open")) 
        return "view_form";
    else if(getParameter("action")=="view")      //Get parameter by GET (command pattern, links)
        return "view_form";
    else if(getParameter("action")=="view_edit")
        return "view_form";
    else if(getParameter("start"))
        return "start";
    else if(getParameter("stop"))
        return "stop";
    else if(getParameter("sync"))
        return "sync";
    else
        return "report"; //cancel
}

function readValueFromConf($key)
{
    $keyInConf = strtoupper($key);
    $dir =  "/etc/pbxconnect";
    if($key=="port"){
        $file = "sys_http.conf";
    }else{
        $file = getRightFile($dir,$keyInConf);
    }
    $pConfig = new paloConfig($dir,$file,"=","\s*=\s*");
    $content = $pConfig->leer_configuracion(FALSE);
    $para = $pConfig->privado_get_valor($content,$keyInConf);
    //print_r($key."=====>".$file."======>".$para."<br>");
    return $para;
}

function savePost($key,$value)
{
    $keyInConf = strtoupper($key);
    $dir =  "/etc/pbxconnect";
    if($key=="port"){
        $file = "sys_http.conf";
        saveToSync($value);
    }else{
        $file = getRightFile($dir,$keyInConf);
    }
    $pConfig = new paloConfig($dir,$file,"=","\s*=\s*");
    $content = $pConfig->leer_configuracion(FALSE);
    $para = $pConfig->privado_get_valor($content,$keyInConf);
    if($para !== $value){
        $arrReplaces = array($keyInConf => $value);
        $pConfig->escribir_configuracion($arrReplaces); 
    }
}

function getRightFile($dir,$keyInConf)
{
    $handle = opendir($dir);
    if($handle) {
        while(false !== ($file = readdir($handle))) {
            if ($file != '.' && $file != '..') {
                $filename = $dir . "/"  . $file;
                $data = file_get_contents($filename);
                if(strpos($data, $keyInConf)){
                    $rightFile=$file;
                    break;
                }else
                    $rightFile="";
            }
        }
        closedir($handle);
    }
    return $rightFile;
}

function saveToSync($value)
{
    $file = "/usr/pbxconnect/force_sync";
    $sync = "sync";
    $command = "wget -qO- http://127.0.0.1:";
    $data = file($file); 
    $oldLine = getLine($data);
    $newLine = $command.$value."/".$sync;
    $new_data = str_replace($oldLine,$newLine,$data);
    file_put_contents($file,$new_data);
}

function getLine($data)
{
    $sync = "sync";
    foreach($data as $line){
        if(strpos($line, $sync)){
            $oldLine = $line;
        }
    }
    return $oldLine;
}

function introduction()
{
$introduction = '
<body>
    <h2>Installation prerequisites check</h2>
    <div class="instructions">
        <h4>Firewall</h4>
        Please make sure you have opened the <b>HTTP port</b> on your firewall<br />
    </div>

    <h2>Instruction</h2>
    <div class="instructions">
        <h4>Step 1</h4>
        All settings on above need to be configured. Press "Save" button to apply the changes.
    </div>
    <div class="instructions">
        <h4>Step 2</h4>
        Modify asterisk dialplan (extensions_custom.conf will be used in this instruction).<br />
        Go to page "PBX"-->"Tools" tab-->"Asterisk File Editor", select file "extensions_custom.conf".<br />
        Copy: <b>#include extensions_opticaller.conf</b><br />
        Paste to extensions_custom.conf.<br /><br />
        Copy: <b>exten => _4612345678,1,Dial(LOCAL/${EXTEN}@pbxconnect-inbound/n) </b><br />
        Paste to one\'s own inbound logic context in extensions_custom.conf. <br />
        Change "4612345678" to "Data_AccNum_List" which was set on above. <br /><br />
        
        Inbound example if you have 1 access number:<br />
        [inbound-contex]<br />
        exten => _4612345678,1,1,Dial(LOCAL/${EXTEN}@pbxconnect-inbound/n) <br /><br />

        
        Copy:<br /><b>
        [pbxconnect-outbound]   <br />
        exten => _X.,1,Dial(LOCAL/${EXTEN}@customer-outbound-logic/n) </b><br />
        Paste to extensions_custom.conf. <br />
        Change <b>"customer-outbound-logic"</b> according to one\'s own outbound logic context. <br /><br />

        Outbound example: <br />

        [pbxconnect-outbound]<br />
        exten => _X.,1,Dial(SIP/YOUR-OUTBOUND-TRUNK-HERE/${EXTEN},60)<br /><br />

        Save extensions_custom.conf, and Reload Asterisk.
     </div>
     <div class="instructions">
        <h4>Step 3</h4>
        Press "Start Module" button to run the module.
     </div>
</body>';
return $introduction;
}
?>
